Subject: Re: bug#9963: ./temacs -Q -nw abort in bidi_initialize

From: Dan Nicolaescu <[email-masked]>
Date: Sun, 06 Nov 2011 18:10:23 -0500

Eli Zaretskii <[email-masked]> writes:

>> Date: Sun, 06 Nov 2011 02:24:43 -0500
>> From: Eli Zaretskii <[email-masked]>
>> Cc: [email-masked]
>> 
>> > > This abort means you somehow have a problem loading uni-bidi.el, or
>> > > didn't load it at all, or perhaps load a wrong uni-bidi.el (e.g., from
>> > > Emacs 23).  It is strange that it works without -nw, though.
>> > 
>> > It looks this happens when printing the first "Loading" message at
>> > startup to load loadup.el.
>> 
>> That figures: Emacs needs uni-bidi for display, and `message' enters
>> redisplay.
>> 
>> >  Is uni-bidi.el loaded before that?
>> 
>> Evidently, it isn't.  I think it is pulled in when charprop is loaded,
>> but that's half-way down loadup.el.
>> 
>> We need to find a way of loading uni-bidi and uni-mirrored before
>> loading loadup.el.  I will get to that later today, if no one beats me
>> to it.
>
> I think I fixed this (revision 106305 on the trunk), please check.

Thanks for the quick fix, it looks like everything works fine.

> For the record: I decided that loading uni-bidi in advance is not a
> good idea, as proper functioning of character property tables needed
> by bidi.c depends on many other *.el files that are normally loaded
> before uni-bidi.  There be dragons there.  So instead, I disabled bidi
> reordering for as long as purify-flag is non-nil; I hope this is TRT
> for all supported configurations, including CANNOT_DUMP.

Agreed.